import socket
__author__ = 'jacobshutzman1'

SERVER = '127.0.0.1'  # Communicate with a domain name
PORT = 1729


def initial_contact(ip, port):
    """ Sends the first hand-shake to the server and ask for the
        services it provides.
    """
    client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    client_socket.connect((ip, port))
    message = "Hello server, what kind of services do you provide? "
    client_socket.send(message)
    result = client_socket.recv(48)
    print result
    return result, client_socket


def send_requests(res, client_socket):
    result = res
    while len(result) > 0:
        message = raw_input('Enter your selection, please: ')
        # Ignore the user if she wants to send more than 4 charachters
        message = message[:4]
        client_socket.send(message)
        # First four bytes contain the message we receive, has the length
        result = client_socket.recv(4)
        if result:
            message_length = int(result)
            result = client_socket.recv(message_length)
            print result
        else:
            result = ''
    client_socket.close()


def main():
    """ Asking the server for the type of services it provides, then
        loop on requests.
    """
    result, socket = initial_contact(SERVER, PORT)
    send_requests(result, socket)

if __name__ == '__main__':
    main()