from Tkinter import *
import Tkinter as tk
from server27 import *
from client27 import *
from threading import *
__author__ = 'jacobshutzman1'
"""
   A small GUI interface to activate the client/server. After the
   activation by pressing thebuttons, the rest ofte dialogue is
   conducted through the console. The exit button deletes the window
   of the interface. It uses threads: server, client, in order not to
   hang the GUI window.
"""

win = Tk()


def client():
    """ calls the actual client program. """
    mainclient()


def server():
    """ calls the actual server program. """
    mainserver()


def startclient():
    """ Activated by pressing action1 button. """
    th2 = Thread(target=client)
    th2.start()


def startserver():
    """ Activated by pressing action2 button. """
    th1 = Thread(target=server)
    th1.start()


def exit():
    """ Exit the GUI window """
    global win
    win.destroy()
    win.quit()


def main():

    try:
        while True:
            win.geometry('{}x{}'.format(300, 250))
            win.title('Welcome to the world of Client/Server with Sockets')
            win.configure(background='yellow')

            lbl = tk.Label(win, text="To activate Cient / Server select: ",
                           bg='sky blue').grid(
                           row=0, column=0, columnspan=6, sticky='e')

            action1 = tk.Button(win, text="Start Client",
                                command=lambda: startclient())
            action1.configure(relief='raised', borderwidth=5,
                              font='Verdana 16')
            action1.grid(column=2, row=2, sticky='E')

            action2 = tk.Button(win, text="Start Server",
                                command=lambda: startserver())
            action2.configure(relief='raised', borderwidth=5,
                              font='Verdana 16')
            action2.grid(column=1, row=2, sticky='W')

            action3 = tk.Button(win, text="Exit all", command=lambda: exit())
            action3.grid(column=1, row=4, columnspan=4, padx=5, sticky='W')
            win.mainloop(0)
    except:
        pass


if __name__ == '__main__':
    main()
