__author__ = 'jacob shutzman'
import re
import sys
import time
i, o, e = sys.stdin, sys.stdout, sys.stderr
from scapy.all import *
sys.stdin, sys.stdout, sys.stderr = i, o, e

"""
   Usege:  my_nslookup url
   Implementation of nslookup (A) with scapy. Finding the IP address of a URL.
   A timeout of 2 seconds was added, for url's that do not respond.
"""


def extract_ip(search_str):
    """ gets a string with summary data including an IP address.
        Extracts and returns the IP address only with a regular expression
    """
    ip_candidates = \
        re.findall(r"\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b", search_str)
    if len(ip_candidates) == 1:
        return ip_candidates[0]


def main():
    if len(sys.argv) != 2:
        print "Usage is: my_nslookup.py  url"
    else:
        arg1 = sys.argv[1]
        dns_packet = IP(dst='8.8.8.8') / UDP(sport=24601, dport=53) \
            / DNS(qdcount=1, rd=1) / DNSQR(qname=arg1)
        # If sr1 times out, send a message of unavailability
        start_sending = time.time()
        response_packet = sr1(dns_packet, timeout=2)
        end_sending = time.time()
        ip_address = ''
        if end_sending - start_sending < 1.9:
            data = response_packet.summary()
            ip_address = extract_ip(data)
        if ip_address:
            print 'The ip address of: ' + arg1 + ' is: ' + ip_address
        else:
            print 'The ip address of: ' + arg1 + ' is currently unavailable'

if __name__ == '__main__':
    main()