# -*- coding: utf-8 -*-
import sys
i, o, e = sys.stdin, sys.stdout, sys.stderr
from scapy.all import *
sys.stdin, sys.stdout, sys.stderr = i, o, e
SERVER = '10.0.0.11'  # Communicate with a domain name
BLKSIZE = 36  # Suggestion: 1024
SEQ_LENGTH = 4
FILE_TO_FTP = 'minialice.txt'


def send_file(filename, ip):
    """ Gets a file to send and an IP. It sends it in BLKSIZE chunks.
        I tested with small files to get many drops (36 bytes chunks)
    """
    try:
        file_handle = open(filename, 'rb')
    except Exception as e:
        print e.message
    try:
        chunk = file_handle.read(BLKSIZE)
    except:
        print 'read failed'
    print 'sending the file...'
    # The first 4 bytes of every chunk will be a sequence number of
    # the packet.
    chunk_seq = 1
    while (chunk):
        raw_data = sequence_packet(chunk_seq, chunk)
        saved_data = raw_data
        my_packet = IP(dst=ip)/ICMP(type="echo-request")/raw_data
        send(my_packet)
        chunk_seq += 1     # Prepare for the next chunk
        response = sniff(filter="icmp and host "+ip, count=1)
        # Verify that the server got the chunk. The server returns the seq.
        # as a form of acknowledgement. It sends the next if received ok.
        if response:
            ack = str(response[0][Raw])
            num_ack = int(ack)
            print 'num_ack=', num_ack, 'chunk_seq= ', chunk_seq
            # If the response has different sequence, try again
            while response and num_ack != chunk_seq:
                my_packet = IP(dst=ip)/ICMP(type="echo-request")/saved_data
                send(my_packet)  # Try to send again the missing packet
                response = sniff(filter="icmp and host "+ip, count=1)
                if response:
                    ack = str(response[0][Raw])
                    num_ack = int(ack)
                    print "after packet missed, num_ack=", num_ack
        else:
            print 'response was None'
        chunk = file_handle.read(BLKSIZE)

    file_handle.close()
    last_packet = IP(dst=ip)/ICMP(type="echo-request")/"0000"
    send(last_packet)
    print 'finished sending file'


def sequence_packet(current_seq, message):
    """ Receives a message and returns: sequence_number+message
        The first 4 bytes of the response is its seq.
    """
    sequence = str(current_seq)
    sequence = sequence.zfill(SEQ_LENGTH)  # fill with zeros on the left
    message_back = sequence + message
    return message_back


def main():
    """
    The program sends a file with a 'make shift' FTP, using 'ping' echo tool
    with Scapy prepared packets (the raw data include the file chunks.
    """
    ip = SERVER
    file_send = FILE_TO_FTP
    send_file(file_send, ip)


if __name__ == '__main__':
    main()