# -*- coding: utf-8 -*-
import sys
import random
i, o, e = sys.stdin, sys.stdout, sys.stderr
from scapy.all import *
sys.stdin, sys.stdout, sys.stderr = i, o, e
CLIENT = '10.0.0.11'  # Communicate with a domain name
PICK = 5


def seq_strip(message):
    """ Separates the message into its sequence number and data
    """
    seq_part = int(message[:4])
    data_part = message[4:]
    return seq_part, data_part


def lose_packet(p_number):
    """ Intentionally drop a packet with a 10% chance,
        to simulate recovery protocol. """
    rnd_selection = random.randint(1, 10)
    if rnd_selection == PICK:  # 10% chance for PICK
        return p_number+1      # packet "dropped"
    return p_number


def main():
    """
    This server sends back an acknowledgement every time a sequence number
    gets out of order (possibly packet dropped). It sends the missing
    number in the sequence (same sequence sent by the client). If all is
    fine, it sends back the next sequence it expects to get.
    """
    print " Server is up, waiting to get a file"
    ended = False
    last_received = 0
    ip = CLIENT
    rcv_file = open('file_received', 'w')   # Write out the received file
    while not ended:
        # print 'Server last received=', last_received
        message = sniff(filter="icmp and host "+ip, count=1)
        if message:
            last_received += 1
            data = message[0][Raw]
            seq_recv, chunk_data = seq_strip(str(data))
            seq_recv = lose_packet(seq_recv)
            if seq_recv != last_received and seq_recv != 0:
                print "missing packet"
                ret_packet = IP(dst=ip)/ICMP(type="echo-request")/\
                             str(last_received)
                send(ret_packet)
                last_received -= 1  # Not received, so subtract 1
            elif seq_recv != 0:
                seq_recv += 1       # send the next chunk, all is fine.
                rcv_file.write(chunk_data)
                ret_seq = str(seq_recv)
                ret_packet = IP(dst=ip)/ICMP(type="echo-request")/ret_seq
                # print 'sending confirmation for: ', ret_seq
                send(ret_packet)
            else:
                print 'no more messages'
                rcv_file.close()
                ended = True
        else:  # sending ended
            print "sending ended"


if __name__ == '__main__':
    main()